//+------------------------------------------------------------------+
//|                                                         Bull.mq4 |
//|                                                     Igor Morozov |
//|                                    http://www.herbspirit.com/mql |
//+------------------------------------------------------------------+
#property copyright "Igor Morozov"
#property link      "http://www.herbspirit.com/mql"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Yellow
//---- input parameters
extern int       bbPeriod=10;
extern int       Bull=7;
extern int       Bear=3;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

bool IndActive;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndActive=true;
  if(bbPeriod<1||bbPeriod>Bars)
  		ParamError("Invalid bbPeriod parameter "+bbPeriod);
  if(Bull<Bear||Bull>bbPeriod)		
  		ParamError("Invalid Bull parameter "+Bull);
  if(Bear<0||Bear>Bull)		
  		ParamError("Invalid Bear parameter "+Bear);
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,217);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,218);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  	if(!IndActive)
  		return(0);
   int    counted_bars=IndicatorCounted();
   int shift=MathMax(Bars-counted_bars,WindowBarsPerChart());
   while(shift>0)
   {
   	double vertshift=(WindowPriceMax()-WindowPriceMin())/100;
   	int bbValue=bbCount(shift);
   	if(bbValue>=Bull)
   		ExtMapBuffer2[shift-1]=High[shift-1]+vertshift;
   	if(bbValue<=Bear)
   		ExtMapBuffer1[shift-1]=Low[shift-1]-vertshift;
   	shift--;
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

int bbCount(int shift)
{
	int count;
	for(int i=shift;i<shift+bbPeriod;i++)
	{
		if(Close[i]>Close[i+1])
			count++;
	}	
	return(count);
}

void ParamError(string msg)
{
	Print(msg);
	IndActive=false;
}

